@echo off

:: Hold on to the directory the batch file is currently running from
set cur_dir=%~dp0

copy "%cur_dir%_setup_files\*.sh" "%cur_dir%"
copy "%cur_dir%_setup_files\make.bat" "%cur_dir%"

:: Make sure output directories exist
if NOT EXIST "%cur_dir%\_build\win32\vs6" md "%cur_dir%\_build\win32\vs6"
if NOT EXIST "%cur_dir%\_build\win32\vs9" md "%cur_dir%\_build\win32\vs9"
if NOT EXIST "%cur_dir%\_build\osx" md "%cur_dir%\_build\osx"
if NOT EXIST "%cur_dir%\_build\ios" md "%cur_dir%\_build\ios"
if NOT EXIST "%cur_dir%\_build\android\debug" md "%cur_dir%\_build\android\debug"
if NOT EXIST "%cur_dir%\_build\android\release" md "%cur_dir%\_build\android\release"
if NOT EXIST "%cur_dir%\bin\android\debug" md "%cur_dir%\bin\android\debug"
if NOT EXIST "%cur_dir%\bin\android\release" md "%cur_dir%\bin\android\release"
if NOT EXIST "%cur_dir%\_build\linux\debug" md "%cur_dir%\_build\linux\debug"
if NOT EXIST "%cur_dir%\_build\linux\release" md "%cur_dir%\_build\linux\release"
if NOT EXIST "%cur_dir%\bin\linux\debug" md "%cur_dir%\bin\linux\debug"
if NOT EXIST "%cur_dir%\bin\linux\release" md "%cur_dir%\bin\linux\release"

::copy android build files
if NOT EXIST "%cur_dir%_setup_files\android" GOTO NO_ANDROID
copy "%cur_dir%_setup_files\android\build.xml" "%cur_dir%_build\android\debug\build.xml"
copy "%cur_dir%_setup_files\android\AndroidManifest.xml" "%cur_dir%_build\android\debug\AndroidManifest.xml"
copy "%cur_dir%_setup_files\android\build.properties.debug" "%cur_dir%_build\android\debug\build.properties"
copy "%cur_dir%_setup_files\android\default.properties" "%cur_dir%_build\android\debug\default.properties"
copy "%cur_dir%_setup_files\android\proguard.cfg" "%cur_dir%_build\android\debug\proguard.cfg"
copy "%cur_dir%_setup_files\android\local.properties" "%cur_dir%_build\android\debug\local.properties"
copy "%cur_dir%_setup_files\android\build.xml" "%cur_dir%_build\android\release\build.xml"
copy "%cur_dir%_setup_files\android\AndroidManifest.xml" "%cur_dir%_build\android\release\AndroidManifest.xml"
copy "%cur_dir%_setup_files\android\build.properties.release" "%cur_dir%_build\android\release\build.properties"
copy "%cur_dir%_setup_files\android\default.properties" "%cur_dir%_build\android\release\default.properties"
copy "%cur_dir%_setup_files\android\proguard.cfg" "%cur_dir%_build\android\release\proguard.cfg"
copy "%cur_dir%_setup_files\android\local.properties" "%cur_dir%_build\android\release\local.properties"
:NO_ANDROID

:: NOTE: CMake must be run from the build directory
:: Create the visual studio solution with cmake
echo.
echo.
echo Creating Visual Studio 6 Solution
cd "%cur_dir%_build\win32\vs6"
cmake -G "Visual Studio 6" ..\..\..\
echo Creating Visual Studio 9 Solution
cd ..\vs9
cmake -G "Visual Studio 9 2008" ..\..\..\

:: Create the android project
echo.
echo.
echo Creating Android project
cd "%cur_dir%_build\android\debug"
cmake -G "NMake Makefiles" -DCMAKE_BUILD_TYPE=Debug -DCMAKE_TOOLCHAIN_FILE="%MK3_ROOT%\mk3_files\android.toolchain.cmake" ..\..\..\
cd ..\release
cmake -G "NMake Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_TOOLCHAIN_FILE="%MK3_ROOT%\mk3_files\android.toolchain.cmake" ..\..\..\

cd %cur_dir%
